diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/zigbee/model/zigbee-nwk.h ns-3.46/src/zigbee/model/zigbee-nwk.h
--- ns-3.45/src/zigbee/model/zigbee-nwk.h	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/zigbee/model/zigbee-nwk.h	2025-10-01 18:46:32.000000000 -0700
@@ -12,6 +12,7 @@
 #ifndef ZIGBEE_NWK_H
 #define ZIGBEE_NWK_H
 
+#include "zigbee-group-table.h"
 #include "zigbee-nwk-fields.h"
 #include "zigbee-nwk-header.h"
 #include "zigbee-nwk-payload-header.h"
@@ -49,7 +50,7 @@
                                                      //!< Page 0 in Zigbee (250kbps O-QPSK)
 
 /**
- * @ingroup zigbee
+ * @ingroup Zigbee
  *
  * Indicates a pending NWK primitive
  */
@@ -67,7 +68,7 @@
 };
 
 /**
- * @ingroup zigbee
+ * @ingroup Zigbee
  *
  * Table 3.2 (Address Mode) NLDE-DATA-Request parameters
  */
@@ -137,7 +138,7 @@
 };
 
 /**
- * @ingroup zigbee
+ * @ingroup Zigbee
  *
  *  Network layer status values
  *  Combines Zigbee Specification r22.1.0 Table 3-73 and
@@ -235,7 +236,7 @@
 std::ostream& operator<<(std::ostream& os, const uint8_t& num);
 
 /**
- * @ingroup zigbee
+ * @ingroup Zigbee
  *
  *  Status codes for network status command frame and route discovery failures.
  *
@@ -265,7 +266,7 @@
 };
 
 /**
- *  @ingroup zigbee
+ *  @ingroup Zigbee
  *
  *  Channel List Structure. See Zigbee Specification 3.2.2.2.1
  */
@@ -283,7 +284,7 @@
 };
 
 /**
- * @ingroup zigbee
+ * @ingroup Zigbee
  *
  * NLDE-DATA.confirm params. See Zigbee Specification 3.2.1.2
  */
@@ -297,7 +298,7 @@
 };
 
 /**
- * @ingroup lr-wpan
+ * @ingroup Zigbee
  *
  * NLDE-DATA.indication params. See Zigbee Specification 3.2.1.3.1
  */
@@ -315,7 +316,7 @@
 };
 
 /**
- * @ingroup zigbee
+ * @ingroup Zigbee
  *
  * NLDE-DATA.request params. See Zigbee Specification 3.2.1.1
  */
@@ -340,7 +341,7 @@
 };
 
 /**
- *  @ingroup zigbee
+ *  @ingroup Zigbee
  *
  *  NLME-NETWORK-FORMATION.request params. See Zigbee Specification 3.2.2.5.1
  */
@@ -372,7 +373,7 @@
 };
 
 /**
- * @ingroup zigbee
+ * @ingroup Zigbee
  *
  * A group of pending parameters arranged into a structure during the execution of
  * a NLME-NETWORK-FORMATION.request primitive.
@@ -385,7 +386,7 @@
 };
 
 /**
- *  @ingroup zigbee
+ *  @ingroup Zigbee
  *
  *  NLME-NETWORK-FORMATION.confirm params. See Zigbee Specification 3.2.2.6.1
  */
@@ -396,14 +397,15 @@
 };
 
 /**
- *  @ingroup zigbee
+ *  @ingroup Zigbee
  *
  *  NLME-ROUTE-DISCOVERY.request params. See Zigbee Specification 3.2.2.33
  */
 struct NlmeRouteDiscoveryRequestParams
 {
     AddressMode m_dstAddrMode{UCST_BCST}; //!< Specifies the kind of destination address.
-    Mac16Address m_dstAddr;               //!< The destination of the route discovery.
+    Mac16Address m_dstAddr;    //!< The 16-bit destination address or Group ID (MCST destination)
+                               //!<  of the route discovery.
     uint16_t m_radius{0};      //!< Optional parameter that describes the number of hops that the
                                //!< route request will travel through the network.
     bool m_noRouteCache{true}; //!< This flag determines whether the NWK should establish a
@@ -411,7 +413,7 @@
 };
 
 /**
- *  @ingroup zigbee
+ *  @ingroup Zigbee
  *
  *  NLME-ROUTE-DISCOVERY.confirm params. See Zigbee Specification r22.1.0, 3.2.2.34
  */
@@ -425,7 +427,7 @@
 };
 
 /**
- *  @ingroup zigbee
+ *  @ingroup Zigbee
  *
  *  NLME-DIRECT-JOIN.request params.
  *  See Zigbee Specification r22.1.0, 3.2.2.16
@@ -438,7 +440,7 @@
 };
 
 /**
- *  @ingroup zigbee
+ *  @ingroup Zigbee
  *
  *  NLME-DIRECT-JOIN.confirm params.
  *  See Zigbee Specification r22.1.0, 3.2.2.17
@@ -452,7 +454,7 @@
 };
 
 /**
- *  @ingroup zigbee
+ *  @ingroup Zigbee
  *
  *  NLME-NETWORK-DISCOVERY.request params.
  *  See Zigbee Specification r22.1.0, 3.2.2.3
@@ -492,7 +494,7 @@
 };
 
 /**
- *  @ingroup zigbee
+ *  @ingroup Zigbee
  *
  *  NLME-NETWORK-DISCOVERY.confirm params. See Zigbee Specification r22.1.0, 3.2.2.4
  */
@@ -506,7 +508,7 @@
 };
 
 /**
- * @ingroup zigbee
+ * @ingroup Zigbee
  *
  * NLME-JOIN.request params.
  * See Zigbee Specification r22.1.0, 3.2.2.13
@@ -528,7 +530,7 @@
 };
 
 /**
- *  @ingroup zigbee
+ *  @ingroup Zigbee
  *
  *  NLME-JOIN.confirm params.
  *  See Zigbee Specification r22.1.0, 3.2.2.15
@@ -560,7 +562,7 @@
 };
 
 /**
- *  @ingroup zigbee
+ *  @ingroup Zigbee
  *
  *  NLME-JOIN.indication params.
  *  See Zigbee Specification r22.1.0, 3.2.2.14
@@ -579,7 +581,7 @@
 };
 
 /**
- * @ingroup zigbee
+ * @ingroup Zigbee
  *
  * NLME-START-ROUTER.request params.
  * See Zigbee Specification r22.1.0, 3.2.2.13
@@ -592,7 +594,7 @@
 };
 
 /**
- * @ingroup zigbee
+ * @ingroup Zigbee
  *
  * NLME-START-ROUTER.confirm params.
  * See Zigbee Specification r22.1.0, 3.2.2.10
@@ -603,86 +605,8 @@
                                                     //!< the corresponding request.
 };
 
-//////////////////////
-//     Callbacks    //
-//////////////////////
-
-/**
- * @ingroup zigbee
- *
- * This callback is called after a NSDU has successfully received and
- *  NWK push it to deliver it to the next higher layer.
- *
- */
-typedef Callback<void, NldeDataIndicationParams, Ptr<Packet>> NldeDataIndicationCallback;
-
-/**
- * @ingroup zigbee
- *
- * This callback is used to notify the next higher layer with a confirmation in response to
- * a previously issued NLDE-DATA.request.
- *
- */
-typedef Callback<void, NldeDataConfirmParams> NldeDataConfirmCallback;
-
-/**
- *  @ingroup zigbee
- *
- *  This callback is used to notify the next higher layer with a confirmation in response to
- *  a previously issued NLME-NETWORK-FORMATION.request.
- */
-typedef Callback<void, NlmeNetworkFormationConfirmParams> NlmeNetworkFormationConfirmCallback;
-
-/**
- *  @ingroup zigbee
- *
- *  This callback is used to notify the next higher layer with a confirmation in response to
- *  a previously issued NLME-NETWORK-DISCOVERY.request.
- */
-typedef Callback<void, NlmeNetworkDiscoveryConfirmParams> NlmeNetworkDiscoveryConfirmCallback;
-
 /**
- *  @ingroup zigbee
- *
- *  This callback is used to notify the next higher layer with a confirmation in response to
- *  a previously issued NLME-ROUTE-DISCOVERY.request.
- */
-typedef Callback<void, NlmeRouteDiscoveryConfirmParams> NlmeRouteDiscoveryConfirmCallback;
-
-/**
- *  @ingroup zigbee
- *
- *  This callback is used to notify the next higher layer with a confirmation in response to
- *  a previously issued NLME-DIRECT-JOIN.request.
- */
-typedef Callback<void, NlmeDirectJoinConfirmParams> NlmeDirectJoinConfirmCallback;
-
-/**
- *  @ingroup zigbee
- *
- *  This callback is used to notify the next higher layer with a confirmation in response to
- *  a previously issued NLME-JOIN.request.
- */
-typedef Callback<void, NlmeJoinConfirmParams> NlmeJoinConfirmCallback;
-
-/**
- *  @ingroup zigbee
- *
- *  This callback is used to notify the next higher layer with an indication that a new
- *  device has successfully joined its network by association or rejoining.
- */
-typedef Callback<void, NlmeJoinIndicationParams> NlmeJoinIndicationCallback;
-
-/**
- *  @ingroup zigbee
- *
- *  This callback is used to notify the next higher layer with a confirmation in response to
- *  a previously issued NLME-START-ROUTER.request.
- */
-typedef Callback<void, NlmeStartRouterConfirmParams> NlmeStartRouterConfirmCallback;
-
-/**
- * @ingroup zigbee
+ * @ingroup Zigbee
  *
  * Class that implements the Zigbee Specification Network Layer
  */
@@ -703,6 +627,60 @@
     ~ZigbeeNwk() override;
 
     /**
+     * This callback is called after a NSDU has successfully received and
+     *  NWK push it to deliver it to the next higher layer.
+     */
+    using NldeDataIndicationCallback = Callback<void, NldeDataIndicationParams, Ptr<Packet>>;
+
+    /**
+     * This callback is used to notify the next higher layer with a confirmation in response to
+     * a previously issued NLDE-DATA.request.
+     */
+    using NldeDataConfirmCallback = Callback<void, NldeDataConfirmParams>;
+
+    /**
+     *  This callback is used to notify the next higher layer with a confirmation in response to
+     *  a previously issued NLME-NETWORK-FORMATION.request.
+     */
+    using NlmeNetworkFormationConfirmCallback = Callback<void, NlmeNetworkFormationConfirmParams>;
+
+    /**
+     *  This callback is used to notify the next higher layer with a confirmation in response to
+     *  a previously issued NLME-NETWORK-DISCOVERY.request.
+     */
+    using NlmeNetworkDiscoveryConfirmCallback = Callback<void, NlmeNetworkDiscoveryConfirmParams>;
+
+    /**
+     *  This callback is used to notify the next higher layer with a confirmation in response to
+     *  a previously issued NLME-ROUTE-DISCOVERY.request.
+     */
+    using NlmeRouteDiscoveryConfirmCallback = Callback<void, NlmeRouteDiscoveryConfirmParams>;
+
+    /**
+     *  This callback is used to notify the next higher layer with a confirmation in response to
+     *  a previously issued NLME-DIRECT-JOIN.request.
+     */
+    using NlmeDirectJoinConfirmCallback = Callback<void, NlmeDirectJoinConfirmParams>;
+
+    /**
+     *  This callback is used to notify the next higher layer with a confirmation in response to
+     *  a previously issued NLME-JOIN.request.
+     */
+    using NlmeJoinConfirmCallback = Callback<void, NlmeJoinConfirmParams>;
+
+    /**
+     *  This callback is used to notify the next higher layer with an indication that a new
+     *  device has successfully joined its network by association or rejoining.
+     */
+    using NlmeJoinIndicationCallback = Callback<void, NlmeJoinIndicationParams>;
+
+    /**
+     *  This callback is used to notify the next higher layer with a confirmation in response to
+     *  a previously issued NLME-START-ROUTER.request.
+     */
+    using NlmeStartRouterConfirmCallback = Callback<void, NlmeStartRouterConfirmParams>;
+
+    /**
      * Set the underlying MAC to use in this Zigbee NWK
      *
      * @param mac The pointer to the underlying LrWpan MAC to set to this Zigbee NWK
@@ -710,6 +688,13 @@
     void SetMac(Ptr<lrwpan::LrWpanMacBase> mac);
 
     /**
+     * Get the group table used by this Zigbee NWK.
+     *
+     * @param groupTable The pointer to the group table to set.
+     */
+    void SetGroupTable(Ptr<ZigbeeGroupTable> groupTable);
+
+    /**
      * Get the underlying MAC used by the current Zigbee NWK.
      *
      * @return The pointer to the underlying MAC object currently connected to the Zigbee NWK.
@@ -1284,6 +1269,12 @@
     BroadcastTransactionTable m_btt;
 
     /**
+     *  The Group Table used by this Zigbee NWK.
+     *  See Zigbee specification r22.1.0, 3.6.3.2
+     */
+    Ptr<ZigbeeGroupTable> m_nwkGroupIdTable;
+
+    /**
      * Enqueue a packet in the pending transmission queue until
      * a route is discovered for its destination.
      *
@@ -1446,6 +1437,30 @@
                      ZigbeePayloadRouteReplyCommand payload);
 
     /**
+     *  Process a Multicast Frame received as a member of a multicast group.
+     *  See Zigbee specification r22.1.0 Section 3.6.6.3
+     *
+     * @param nwkHeader The network header of the received multicast frame.
+     * @param msdu The MSDU (MSDU = MAC Service Data Unit) received
+     * @param params The MCPS-DATA.indication parameters associated to the received frame.
+     */
+    void ReceiveMulticastMemberFrame(ZigbeeNwkHeader nwkHeader,
+                                     Ptr<Packet> msdu,
+                                     lrwpan::McpsDataIndicationParams params);
+
+    /**
+     *  Process a Multicast Frame received as a non member of a multicast group.
+     *  See Zigbee specification r22.1.0 Section 3.6.6.4
+     *
+     * @param nwkHeader The network header of the received multicast frame.
+     * @param msdu The MSDU (MSDU = MAC Service Data Unit) received
+     * @param params The MCPS-DATA.indication parameters associated to the received frame.
+     */
+    void ReceiveMulticastNonMemberFrame(ZigbeeNwkHeader nwkHeader,
+                                        Ptr<Packet> msdu,
+                                        lrwpan::McpsDataIndicationParams params);
+
+    /**
      *  Returns true if the address is a broadcast address according to
      *  Zigbee specification r22.1.0, Section 3.6.5, Table 3-69
      *
@@ -1481,6 +1496,18 @@
     void SendDataBcst(Ptr<Packet> packet, uint8_t nwkHandle);
 
     /**
+     * Send a data multicast packet to all the members of a multicast group.
+     *
+     * @param packet The NPDU (nwkHeader + data payload) to transmit.
+     * @param nwkHandle The NWK handle associated to this packet (nsdu handle).
+     *                  A handle of 0 implies that the unicast transmission is a
+     *                  retransmission and do not requires a handle which is
+     *                  used to identify a packet in confirmations to
+     *                  requests (NLDE-DATA.confirm).
+     */
+    void SendDataMcst(Ptr<Packet> packet, uint8_t nwkHandle);
+
+    /**
      * Find the next hop in route to a destination.
      *
      * See RouteDiscoveryStatus enumeration for full information on the returned status.
@@ -1527,6 +1554,11 @@
     Ptr<UniformRandomVariable> m_rreqJitter;
 
     /**
+     *  Provides uniform random values for the broadcast jitter
+     */
+    Ptr<UniformRandomVariable> m_bcstJitter;
+
+    /**
      * Temporarily store beacons information from POS routers and PAN coordinators
      * during a network-discovery process.
      */
@@ -1613,6 +1645,14 @@
      */
     double m_nwkcMaxRREQJitter;
 
+    /**
+     * Minimum Broadcast jitter time (msec).
+     * Zigbee Specification r22.1.0, Table 3-57. Defined as a constant
+     * in the specification but here is defined as variable to allow the selection of values
+     * per device.
+     */
+    double m_nwkcMaxBroadcastJitter;
+
     //////////////////////////////
     // Network layer attributes //
     //////////////////////////////
@@ -1763,6 +1803,7 @@
      * The maximum time duration in milliseconds allowed for the parent all the child devices to
      * retransmit a broadcast message.
      * See Zigbe Specification r22.1.0, Table 3-58 (NIB attributes)
+     * See Zigbee-2007 Layer PICS and Stack Profiles
      */
     Time m_nwkPassiveAckTimeout;
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/zigbee/model/zigbee-nwk-header.cc ns-3.46/src/zigbee/model/zigbee-nwk-header.cc
--- ns-3.45/src/zigbee/model/zigbee-nwk-header.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/zigbee/model/zigbee-nwk-header.cc	2025-10-01 18:46:32.000000000 -0700
@@ -175,6 +175,42 @@
 }
 
 void
+ZigbeeNwkHeader::SetMulticastMode(MulticastMode mode)
+{
+    m_mcstMode = mode;
+}
+
+MulticastMode
+ZigbeeNwkHeader::GetMulticastMode() const
+{
+    return m_mcstMode;
+}
+
+void
+ZigbeeNwkHeader::SetNonMemberRadius(uint8_t radius)
+{
+    m_nonMemberRadius = radius;
+}
+
+uint8_t
+ZigbeeNwkHeader::GetNonMemberRadius() const
+{
+    return m_nonMemberRadius;
+}
+
+void
+ZigbeeNwkHeader::SetMaxNonMemberRadius(uint8_t radius)
+{
+    m_maxNonMemberRadius = radius;
+}
+
+uint8_t
+ZigbeeNwkHeader::GetMaxNonMemberRadius() const
+{
+    return m_maxNonMemberRadius;
+}
+
+void
 ZigbeeNwkHeader::SetFrameControl(uint16_t frameControl)
 {
     m_fctrlFrmType = static_cast<NwkType>((frameControl) & (0x03));                  // Bit 0-1
@@ -217,13 +253,13 @@
 uint8_t
 ZigbeeNwkHeader::GetMulticastControl() const
 {
-    uint8_t val = 0;
+    uint8_t mcstCtrl = 0;
 
-    val = m_mcstMode & (0x03);                        // Bit 0-1
-    val |= (m_nonMemberRadius << 2) & (0x07 << 2);    // Bit 2-4
-    val |= (m_maxNonMemberRadius << 5) & (0x07 << 5); // Bit 5-7
+    mcstCtrl = m_mcstMode & (0x03);                        // Bit 0-1
+    mcstCtrl |= (m_nonMemberRadius << 2) & (0x07 << 2);    // Bit 2-4
+    mcstCtrl |= (m_maxNonMemberRadius << 5) & (0x07 << 5); // Bit 5-7
 
-    return val;
+    return mcstCtrl;
 }
 
 void
@@ -280,8 +316,8 @@
 
     if (m_fctrlMcst)
     {
-        uint8_t multicastControl = i.ReadU8();
-        SetMulticastControl(multicastControl);
+        uint8_t mcstCtrl = i.ReadU8();
+        SetMulticastControl(mcstCtrl);
     }
 
     // TODO: Add Source route subframe when supported
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/zigbee/model/zigbee-nwk-header.h ns-3.46/src/zigbee/model/zigbee-nwk-header.h
--- ns-3.45/src/zigbee/model/zigbee-nwk-header.h	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/zigbee/model/zigbee-nwk-header.h	2025-10-01 18:46:32.000000000 -0700
@@ -199,6 +199,48 @@
      */
     Mac64Address GetSrcIeeeAddr() const;
 
+    /**
+     * Set the multicast mode
+     *
+     * @param mode The multicast mode (member or non-member)
+     */
+    void SetMulticastMode(MulticastMode mode);
+
+    /**
+     * Get the multicast mode
+     *
+     * @return The multicast mode (member or non-member)
+     */
+    MulticastMode GetMulticastMode() const;
+
+    /**
+     * Set the non-member radius
+     *
+     * @param radius The non-member radius (0-7)
+     */
+    void SetNonMemberRadius(uint8_t radius);
+
+    /**
+     * Get the non-member radius
+     *
+     * @return The non-member radius (0-7)
+     */
+    uint8_t GetNonMemberRadius() const;
+
+    /**
+     * Set the maximum non-member radius
+     *
+     * @param radius The maximum non-member radius (0-7)
+     */
+    void SetMaxNonMemberRadius(uint8_t radius);
+
+    /**
+     * Get the maximum non-member radius
+     *
+     * @return The maximum non-member radius (0-7)
+     */
+    uint8_t GetMaxNonMemberRadius() const;
+
     void Serialize(Buffer::Iterator start) const override;
     uint32_t Deserialize(Buffer::Iterator start) override;
     uint32_t GetSerializedSize() const override;
@@ -223,7 +265,7 @@
      */
     uint16_t GetFrameControl() const;
     /**
-     * Set the Multicast control field
+     * Set the Multicast control field (mcstMode, nonMemberRadius, maxNonMemberRadius)
      * @param multicastControl 8 bits representing the multicast control field
      */
     void SetMulticastControl(uint8_t multicastControl);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/zigbee/model/zigbee-nwk-payload-header.cc ns-3.46/src/zigbee/model/zigbee-nwk-payload-header.cc
--- ns-3.45/src/zigbee/model/zigbee-nwk-payload-header.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/zigbee/model/zigbee-nwk-payload-header.cc	2025-10-01 18:46:32.000000000 -0700
@@ -301,6 +301,18 @@
 }
 
 void
+ZigbeePayloadRouteRequestCommand::SetMulticastField(bool mcst)
+{
+    m_cmdOptMcst = mcst;
+}
+
+bool
+ZigbeePayloadRouteRequestCommand::GetMulticastField() const
+{
+    return m_cmdOptMcst;
+}
+
+void
 ZigbeePayloadRouteRequestCommand::SetCmdOptionField(uint8_t cmdOptionField)
 {
     m_cmdOptManyToOne = static_cast<ManyToOne>((cmdOptionField >> 3) & (0x03)); // Bit 3-4
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/zigbee/model/zigbee-nwk-payload-header.h ns-3.46/src/zigbee/model/zigbee-nwk-payload-header.h
--- ns-3.45/src/zigbee/model/zigbee-nwk-payload-header.h	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/zigbee/model/zigbee-nwk-payload-header.h	2025-10-01 18:46:32.000000000 -0700
@@ -77,11 +77,14 @@
 
     /**
      * Set the command frame type
+     *
      * @param nwkCmd the command frame type
      */
     void SetCmdType(enum NwkCommandType nwkCmd);
+
     /**
      * Get the command frame type
+     *
      * @return The command type from the command payload header
      */
     NwkCommandType GetCmdType() const;
@@ -93,7 +96,8 @@
 /**
  * @ingroup zigbee
  * Represent a variable portion of the zigbee payload header that includes
- * the route request command
+ * the route request command.
+ * See Zigbee specification r22.1.0, Section 3.4.1
  */
 class ZigbeePayloadRouteRequestCommand : public Header
 {
@@ -126,36 +130,42 @@
 
     /**
      * Set the Route request identifier
+     *
      * @param id the route request identifier
      */
     void SetRouteReqId(uint8_t id);
 
     /**
      * Get the Route request identifier
+     *
      * @return the route request identifier
      */
     uint8_t GetRouteReqId() const;
 
     /**
      * Set Destination address
+     *
      * @param addr The destination address (16 bit)
      */
     void SetDstAddr(Mac16Address addr);
 
     /**
      * Get the Destination address
+     *
      * @return the Destination address (16bits)
      */
     Mac16Address GetDstAddr() const;
 
     /**
      * Set the path cost
+     *
      * @param cost the path cost
      */
     void SetPathCost(uint8_t cost);
 
     /**
      * Set the path cost
+     *
      * @return the path cost
      */
     uint8_t GetPathCost() const;
@@ -168,17 +178,35 @@
     bool IsDstIeeeAddressPresent() const;
 
     /**
-     *  Set the destination IEEE address
+     *  Set the destination IEEE address, also automatically
+     *  sets the command option DstIeeeAddr field
+     *
      *  @param dst The destination IEEE address (64 bits)
      */
     void SetDstIeeeAddr(Mac64Address dst);
 
     /**
-     * Get the destination IEEE address
+     * Get the destination IEEE address (64-bit) contained in the
+     * route request command.
+     *
      * @return The destination IEEE address (64bits)
      */
     Mac64Address GetDstIeeeAddr() const;
 
+    /**
+     * Set the command option multicast field
+     *
+     * @param mcst True if the command option multicast field is active
+     */
+    void SetMulticastField(bool mcst);
+
+    /**
+     * Get the command option multicast field
+     *
+     * @return True if the command option multicast field is active
+     */
+    bool GetMulticastField() const;
+
   private:
     /**
      * Set the complete command option field of the route request command.
@@ -208,7 +236,8 @@
 /**
  * @ingroup zigbee
  * Represent a variable portion of the zigbee payload header that includes
- * the route reply command
+ * the route reply command.
+ * See Zigbee specification r22.1.0, Section 3.4.2
  */
 class ZigbeePayloadRouteReplyCommand : public Header
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/zigbee/model/zigbee-nwk-tables.cc ns-3.46/src/zigbee/model/zigbee-nwk-tables.cc
--- ns-3.45/src/zigbee/model/zigbee-nwk-tables.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/zigbee/model/zigbee-nwk-tables.cc	2025-10-01 18:46:32.000000000 -0700
@@ -1327,6 +1327,14 @@
 }
 
 void
+BroadcastTransactionTable::Delete(uint8_t seq)
+{
+    std::erase_if(m_broadcastTransactionTable, [&seq](Ptr<BroadcastTransactionRecord> entry) {
+        return entry->GetSeqNum() == seq;
+    });
+}
+
+void
 BroadcastTransactionTable::Purge()
 {
     std::erase_if(m_broadcastTransactionTable, [](Ptr<BroadcastTransactionRecord> btr) {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/zigbee/model/zigbee-nwk-tables.h ns-3.46/src/zigbee/model/zigbee-nwk-tables.h
--- ns-3.45/src/zigbee/model/zigbee-nwk-tables.h	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/zigbee/model/zigbee-nwk-tables.h	2025-10-01 18:46:32.000000000 -0700
@@ -8,8 +8,8 @@
  *  Alberto Gallegos Ramonet <alramonet@is.tokushima-u.ac.jp>
  */
 
-#ifndef ZIGBEE_TABLES_H
-#define ZIGBEE_TABLES_H
+#ifndef ZIGBEE_NWK_TABLES_H
+#define ZIGBEE_NWK_TABLES_H
 
 #include "zigbee-nwk-fields.h"
 
@@ -924,10 +924,10 @@
     void Print(Ptr<OutputStreamWrapper> stream) const;
 
   private:
-    Mac16Address m_srcAddr;        //!< The 16-bit network address of the broadcast initiator.
-    uint8_t m_sequenceNumber;      //!< The RREQ sequence number of the initiator's broadcast.
-    Time m_expirationTime;         //!< An indicator of when the entry expires
-    uint8_t m_broadcastRetryCount; //!< The number of times this BCST has been retried.
+    Mac16Address m_srcAddr;           //!< The 16-bit network address of the broadcast initiator.
+    uint8_t m_sequenceNumber{0};      //!< The RREQ sequence number of the initiator's broadcast.
+    Time m_expirationTime;            //!< An indicator of when the entry expires
+    uint8_t m_broadcastRetryCount{1}; //!< The number of times this BCST has been retried.
 };
 
 /**
@@ -1298,6 +1298,13 @@
     bool LookUpEntry(uint8_t seq, Ptr<BroadcastTransactionRecord>& entryFound);
 
     /**
+     * Delete a broadcast transaction record (BTR) from the broadcast transaction table (BTT).
+     *
+     * @param seq The sequence number of the broadcasted frame to delete.
+     */
+    void Delete(uint8_t seq);
+
+    /**
      * Purge expired entries from the broadcast transaction table (BTT).
      */
     void Purge();
@@ -1324,4 +1331,4 @@
 } // namespace zigbee
 } // namespace ns3
 
-#endif /* ZIGBEE_TABLES_H */
+#endif /* ZIGBEE_NWK_TABLES_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/zigbee/model/zigbee-stack.cc ns-3.46/src/zigbee/model/zigbee-stack.cc
--- ns-3.45/src/zigbee/model/zigbee-stack.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/zigbee/model/zigbee-stack.cc	2025-10-01 18:46:32.000000000 -0700
@@ -40,8 +40,10 @@
     NS_LOG_FUNCTION(this);
 
     m_nwk = CreateObject<zigbee::ZigbeeNwk>();
-    // TODO: Create  APS layer here.
-    //  m_aps = CreateObject<zigbee::ZigbeeAps> ();
+    m_aps = CreateObject<zigbee::ZigbeeAps>();
+    m_groupTable = Create<zigbee::ZigbeeGroupTable>();
+
+    m_nwkOnly = false;
 }
 
 ZigbeeStack::~ZigbeeStack()
@@ -56,7 +58,9 @@
 
     m_netDevice = nullptr;
     m_node = nullptr;
+    m_aps = nullptr;
     m_nwk = nullptr;
+    m_groupTable = nullptr;
     m_mac = nullptr;
     Object::DoDispose();
 }
@@ -66,18 +70,19 @@
 {
     NS_LOG_FUNCTION(this);
 
-    AggregateObject(m_nwk);
-
     NS_ABORT_MSG_UNLESS(m_netDevice,
                         "Invalid NetDevice found when attempting to install ZigbeeStack");
 
     // Make sure the NetDevice is previously initialized
-    // before using ZigbeeStack
+    // before using ZigbeeStack (PHY and MAC are initialized)
     m_netDevice->Initialize();
 
     m_mac = m_netDevice->GetObject<lrwpan::LrWpanMacBase>();
     NS_ABORT_MSG_UNLESS(m_mac,
-                        "No valid LrWpanMacBase found in this NetDevice, cannot use ZigbeeStack");
+                        "Invalid LrWpanMacBase found in this NetDevice, cannot use ZigbeeStack");
+
+    m_nwk->Initialize();
+    AggregateObject(m_nwk);
 
     // Set NWK callback hooks with the MAC
     m_nwk->SetMac(m_mac);
@@ -97,14 +102,27 @@
     m_mac->SetMlmeAssociateConfirmCallback(MakeCallback(&ZigbeeNwk::MlmeAssociateConfirm, m_nwk));
     // TODO: complete other callback hooks with the MAC
 
+    if (!m_nwkOnly)
+    {
+        // Set APS callback hooks with NWK (i.e., NLDE primitives only)
+        m_nwk->SetNldeDataConfirmCallback(MakeCallback(&ZigbeeAps::NldeDataConfirm, m_aps));
+        m_nwk->SetNldeDataIndicationCallback(MakeCallback(&ZigbeeAps::NldeDataIndication, m_aps));
+
+        m_nwk->SetGroupTable(m_groupTable);
+        m_aps->SetGroupTable(m_groupTable);
+
+        m_aps->Initialize();
+        m_aps->SetNwk(m_nwk);
+        AggregateObject(m_aps);
+    }
+    else
+    {
+        m_nwk->SetGroupTable(m_groupTable);
+    }
+
     // Obtain Extended address as soon as NWK is set to begin operations
     m_mac->MlmeGetRequest(MacPibAttributeIdentifier::macExtendedAddress);
 
-    // TODO: Set APS callback hooks with NWK when support for APS layer is added.
-    //       For example:
-    // m_aps->SetNwk (m_nwk);
-    // m_nwk->SetNldeDataIndicationCallback (MakeCallback (&ZigbeeAps::NldeDataIndication, m_aps));
-
     Object::DoInitialize();
 }
 
@@ -134,6 +152,12 @@
     m_node = m_netDevice->GetNode();
 }
 
+void
+ZigbeeStack::SetOnlyNwkLayer()
+{
+    m_nwkOnly = true;
+}
+
 Ptr<zigbee::ZigbeeNwk>
 ZigbeeStack::GetNwk() const
 {
@@ -148,5 +172,19 @@
     m_nwk = nwk;
 }
 
+Ptr<zigbee::ZigbeeAps>
+ZigbeeStack::GetAps() const
+{
+    return m_aps;
+}
+
+void
+ZigbeeStack::SetAps(Ptr<zigbee::ZigbeeAps> aps)
+{
+    NS_LOG_FUNCTION(this);
+    NS_ABORT_MSG_IF(ZigbeeStack::IsInitialized(), "APS layer cannot be set after initialization");
+    m_aps = aps;
+}
+
 } // namespace zigbee
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/zigbee/model/zigbee-stack.h ns-3.46/src/zigbee/model/zigbee-stack.h
--- ns-3.45/src/zigbee/model/zigbee-stack.h	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/zigbee/model/zigbee-stack.h	2025-10-01 18:46:32.000000000 -0700
@@ -10,6 +10,8 @@
 #ifndef ZIGBEE_STACK_H
 #define ZIGBEE_STACK_H
 
+#include "zigbee-aps.h"
+#include "zigbee-group-table.h"
 #include "zigbee-nwk.h"
 
 #include "ns3/lr-wpan-mac-base.h"
@@ -17,7 +19,6 @@
 #include "ns3/traced-callback.h"
 
 #include <stdint.h>
-#include <string>
 
 namespace ns3
 {
@@ -28,6 +29,7 @@
 {
 
 class ZigbeeNwk;
+class ZigbeeAps;
 
 /**
  * @ingroup zigbee
@@ -85,6 +87,20 @@
     void SetNwk(Ptr<ZigbeeNwk> nwk);
 
     /**
+     * Get the APS layer used by this ZigbeeStack.
+     *
+     * @return the APS object
+     */
+    Ptr<ZigbeeAps> GetAps() const;
+
+    /**
+     * Set the APS layer used by this ZigbeeStack.
+     *
+     * @param aps The APS layer object
+     */
+    void SetAps(Ptr<ZigbeeAps> aps);
+
+    /**
      *  Returns a smart pointer to the underlying NetDevice.
      *
      * @return A smart pointer to the underlying NetDevice.
@@ -100,6 +116,11 @@
      */
     void SetNetDevice(Ptr<NetDevice> netDevice);
 
+    /**
+     * Inticates to the Zigbee stack that only the NWK layer should be present.
+     */
+    void SetOnlyNwkLayer();
+
   protected:
     /**
      * Dispose of the Objects used by the ZigbeeStack
@@ -114,8 +135,11 @@
   private:
     Ptr<lrwpan::LrWpanMacBase> m_mac; //!< The underlying LrWpan MAC connected to this Zigbee Stack.
     Ptr<ZigbeeNwk> m_nwk;             //!< The Zigbee Network layer.
-    Ptr<Node> m_node;                 //!< The node associated with this NetDevice.
-    Ptr<NetDevice> m_netDevice;       //!< Smart pointer to the underlying NetDevice.
+    Ptr<ZigbeeAps> m_aps;             //!< The Zigbee Application Support Sub-layer
+    Ptr<ZigbeeGroupTable> m_groupTable; //!< The Zigbee Group Table used by both NWK and APS layers.
+    Ptr<Node> m_node;                   //!< The node associated with this NetDevice.
+    Ptr<NetDevice> m_netDevice;         //!< Smart pointer to the underlying NetDevice.
+    bool m_nwkOnly; //!< Indicates that only the NWK layer is present in the Zigbee stack
 };
 
 } // namespace zigbee
